/*********************************************
******	ADC Vref 2V ʹע	******
**********************************************
ADC(internal Vref 2V)ʹ÷ע
ADCжģʽģʽ(single mode)ظģʽ(repeat mode)

1. ADCʼ
	1-1. ȡADC ڲVref_2V֮ʵֵ(λΪmV), 㴦(VrefReal2048)ʽ£
			(VrefReal2048) = (Vref_2V֮ʵֵ)*2048/2000;
		 Ϊ2000(2Ĵη),Ứ϶ʱ㣬ʽ,
		 ֻ֮2048(2Ĵη),֮ADCУ׼ʱ(ADCת֮˵)
	1-2. ADCת(˵), ȡADC ƫ(ADC_offset)
2. ADCת
	2-1. n(ADC_count)ת, ȡnADC֮ܺ(ADC_sum), (nֵΪ32),
	2-3. (ADC_result)=(ADC_sum)-(ADCƫ), (ADC_result)С(ADCƫ), ȡ(ADC_result)Ϊ0
	2-2. ADCȷΪ:
			(ADC_result) * (VrefReal2048) / 2048 / (ADCת=n)
	2-4. 뽫бתΪunsigned long ̬Լճ̵

ע:
	ȡADCʱȶȡλ(ADCDRL)ٶȡλ(ADCDRH)
***********************************************/
#ifndef __ADC_H_
#define __ADC_H_


//-- ض庯 --//
#ifndef	uchar
#define uchar unsigned char
#endif
#ifndef	uint
#define uint  unsigned int
#endif
#ifndef	ulong
#define ulong unsigned long
#endif


/******************
 * 1st Argument
 * ****************/
#define		ADC_Single		0x1	// תģʽ
#define		ADC_Repeat		0x3	// תģʽ
/******************
 * 2nd Argument
 * ****************/
#define		AIN_DIS			0x0	// ֹģź
#define		AIN_EN			0x1	// ģź
/******************
 * 3rd Argument
 * ****************/
#define		AIN0			0x0	// ѡⲿѹAIN0
#define		AIN1			0x1	// ѡⲿѹAIN1
#define		AIN2			0x2	// ѡⲿѹAIN2
#define		AIN3			0x3	// ѡⲿѹAIN3
#define		AIN4			0x4	// ѡⲿѹAIN4
#define		AIN5			0x5	// ѡⲿѹAIN5
#define		AIN6			0x6	// ѡⲿѹAIN6
#define		AIN7			0x7	// ѡⲿѹAIN7
#define 	AIN8			0x8	// ѡⲿѹAIN8
#define		VDD4_1			0x9	// ѡڲѹ (4֮1 VDD)
#define		AIN_GND      	0xc	// ڲӵ
/******************
 * 4th Argument
 * ****************/
// fcgck=16M... Conv256CLK(16us) ~ Conv1024CLK( 64us)
// fcgck= 8M... Conv128CLK(16us) ~ Conv1024CLK(128us)
// fcgck= 4M... Conv64CLK (16us) ~ Conv512CLK (128us)
// fcgck= 2M... Conv32CLK (16us) ~ Conv256CLK (128us)
#define		Conv32CLK		0x0	// ADתʱ-  32ʱ
#define		Conv64CLK		0x1	// ADתʱ-  64ʱ
#define		Conv128CLK		0x2	// ADתʱ- 128ʱ
#define		Conv256CLK		0x3	// ADתʱ- 256ʱ
#define		Conv512CLK		0x4	// ADתʱ- 512ʱ
#define		Conv1024CLK		0x5	// ADתʱ-1024ʱ
								// (*עתʱӦ趨12.8 us ~ 128 us Χ)
/******************
 * 5th Argument
 * ****************/
#define		Vref2			0x0	// ѡڲ 2Vοѹ
#define		Vref3			0x1	// ѡڲ 3Vοѹ
#define		Vref4			0x2	// ѡڲ 4Vοѹ
#define		VDDVref			0x3	// ѡڲVDDοѹ
#define		EXTVref			0x4	// ѡⲿExtοѹʹAIN3ͬĵ28(P43)Ϊ
								// ⲿοѹ룬ⲿοѹʱʹAIN3Ϊⲿѹ


//-- ȫֱ --//
extern uint  vref_l, vref_h;
extern uchar Flag;
extern ulong iReal_Vref2V, adc_value, adc_GND;
extern ulong VrefReal2048;


uint  GetVref(void);
ulong ADC_detect(uchar, uchar, uchar, uchar);
ulong ADC_ConvCode(uchar, uchar, uchar, uchar);
ulong ADC_ConvVolt(uchar, uchar, uchar, uchar);

#define	ad_test_times	1

#endif


















